searchNodes=[{"doc":"Establishes a websocket connection to the server. Eg : defmodule MyApp.MyClient do use FedecksClient def device_id do { :ok , name } = :inet . hostname ( ) to_string ( name ) end def connection_url do Application . fetch_env! ( :my_app , :fedecks_server_path ) end end Include in your supervision tree. eg defmodule MyApp.Application do children = [ MyApp.MyClient ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Initial authentication to the server with FedecksClient.login/1 . Subsequent connections will authenticate with a token provided by the server, persisting between reboots, until the token expires or otherwise becomes invalid.","ref":"FedecksClient.html","title":"FedecksClient","type":"behaviour"},{"doc":"How long to wait before and between connection attempts. Bear in mind that it my take some time for a network connection to be established if using Nerves Networking and WiFi. Frequent restarts could propagate and take down the application. Optional and defaults to 10 seconds","ref":"FedecksClient.html#c:connect_delay/0","title":"FedecksClient.connect_delay/0","type":"callback"},{"doc":"Send an raw binary message to the server. Implementation provided by the __using__ macro","ref":"FedecksClient.html#c:connection_status/0","title":"FedecksClient.connection_status/0","type":"callback"},{"doc":"Server websocket URL. Must start with &quot;ws://&quot; or &quot;wss://&quot;. Remeber to append &quot;/websocket&quot; if using a Phoenix (ie Fedecks) websocket.","ref":"FedecksClient.html#c:connection_url/0","title":"FedecksClient.connection_url/0","type":"callback"},{"doc":"","ref":"FedecksClient.html#default_connect_delay/0","title":"FedecksClient.default_connect_delay/0","type":"function"},{"doc":"","ref":"FedecksClient.html#default_ping_frequency/0","title":"FedecksClient.default_ping_frequency/0","type":"function"},{"doc":"The default directory for Fedecks tokens. Value is depenendend on the mix environment and target and assumes you are using this for Nerves. If the env is :test or target is :host then it is the module name under the system temp directory. Otherwise &quot;/root/fedecks&quot;","ref":"FedecksClient.html#default_token_dir/2","title":"FedecksClient.default_token_dir/2","type":"function"},{"doc":"Device id to identify this device when communicating with the server","ref":"FedecksClient.html#c:device_id/0","title":"FedecksClient.device_id/0","type":"callback"},{"doc":"Initiate a login to the server. Implementation provided by the __using__ macro","ref":"FedecksClient.html#c:login/1","title":"FedecksClient.login/1","type":"callback"},{"doc":"How often to ping the server to maintain the connection. Bear in mind that the server will drop the connection after 1 minute of inactivity. Optional and defaults to 19 seconds","ref":"FedecksClient.html#c:ping_frequency/0","title":"FedecksClient.ping_frequency/0","type":"callback"},{"doc":"Send an encoded message to the server. Note that the server will use safe decoding so it is best to avoid atoms. Implementation provided by the __using__ macro","ref":"FedecksClient.html#c:send/1","title":"FedecksClient.send/1","type":"callback"},{"doc":"Send an raw binary message to the server. Implementation provided by the __using__ macro","ref":"FedecksClient.html#c:send_raw/1","title":"FedecksClient.send_raw/1","type":"callback"},{"doc":"Subscribe to Fedecks events. Messages are sent in the form {ModuleName, message} . See module doc for messages Implementation provided by the __using__ macro","ref":"FedecksClient.html#c:subscribe/0","title":"FedecksClient.subscribe/0","type":"callback"},{"doc":"Filesystem directory to store the Fedecks Token. Optional and defaults to FedecksClient.default_token_dir/0 (&quot;root/fedecks&quot; on a Nerves installation)","ref":"FedecksClient.html#c:token_dir/0","title":"FedecksClient.token_dir/0","type":"callback"},{"doc":"","ref":"FedecksClient.html#t:connection_status/0","title":"FedecksClient.connection_status/0","type":"type"},{"doc":"This is the client side of Fedecks for device to Phoenix communication over binary websockets. Fedecks Client communicates with Phoenix application using Fececks Server . It is written with Nerves Projects in mind. Connecting your Nerves boxes to a server in the cloud with Websockets gives you efficient two way communication from off your personal projects.","ref":"readme.html","title":"FedecksClient","type":"extras"},{"doc":"Install from Hex. def deps do [ { :fedecks_client , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"FedecksClient - Installation","type":"extras"},{"doc":"First Create a client eg defmodule MyApp.MyClient do use FedecksClient @impl FedecksClient def device_id do { :ok , name } = :inet . hostname ( ) to_string ( name ) end @impl FedecksClient def connection_url do Application . fetch_env! ( :my_app , :fedecks_server_path ) end end Only the FedecksClient.device_id/0 and FedecksClient.connection_url/0 callbacks are required to identify your device to the server, and to locate the Websocket path to the server. The url needs to be in String form and lead with the wss a or ws protocol. You can implement Other optional callbacks to further configure the client: FedecksClient.token_dir/0 , FedecksClient.connect_delay/0 , FedecksClient.ping_frequency/0 . Step 3 Add to your supervision tree eg defmodule MyApp.Application do children = [ MyApp.MyClient ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Step 4 - Authenticate Your Nerves installation will need to authenticate with Fedecks Server at least once. You can do this with the provided implenentation FedecksClient.login/1 . The nature of the credentials is not fixed by Fedecks but is defined by the handler implemented on the Fedecks Server . Authentication serving suggestion: def login ( username , password ) do MyApp.MyClient . login ( %{ &quot;username&quot; =&gt; username , &quot;password&quot; =&gt; password } ) end How you get the authentication credentials to your installation is up to you. I typically run a Phoenix server in my Nerves projects for local access and this kind of configuration. Subsequent reconnections will happen automatically, even between reboots and firmware upgrades. Note that your credentials are not stored locally. Fedecks Server provides and refreshed a signed authentication token to the client which is stored in the filesystem and held in memory. The default token expiry is currently 4 weeks, which is arguably too long. It is configurable on the server side, though . Use it. Send messages up the connection with FedecksClient.send/1 and FedecksClient.send_raw/1 . Subscribe your process to messages received from the server with FedecksClient.subscribe/0 .","ref":"readme.html#using","title":"FedecksClient - Using","type":"extras"},{"doc":"Fedecks Client uses Mint Websocket to connect to the server. Non-raw messages are sent in either direction as Binary Erlang Terms. You could send any message, however decoding is done with the safe option which will not decode any message containing an unknown atom. Out of caution I would suggest avoiding using atoms.","ref":"readme.html#behind-the-curtain","title":"FedecksClient - Behind the curtain","type":"extras"},{"doc":"v0.1.0 Documentation light initial version, pushed up early for Elixir Conf EU Lightning Talks. v0.1.1 More documentation v0.1.2 Change of behaviour on receiving errors during connection upgrade. Previously Fedecks assumed an urecoverable fault; now the connector restarts and tries again. It could be a routing issue causing a 404 or a server side issue which could get resolved.","ref":"changelog.html","title":"Change Log","type":"extras"}]